"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInfo = exports.Info = exports.getErrorCodes = exports.ErrorStatusCodes = exports.getErrorSchema = exports.ErrorSchema = exports.getResponseSchema = exports.ResponseSchema = exports.getRequestSchema = exports.RequestSchema = exports.getSimpleQuerySchema = exports.getQuerySchema = exports.QuerySchema = exports.getParamSchema = exports.ParamSchema = exports.Contract = exports.getApiDocs = exports.ApiDocs = void 0;
require("reflect-metadata");
const APIDOCS = Symbol('avanzu.kernel.apidocs.generator');
const PARAMS = Symbol('avanzu.kernel.apidocs.params');
const QUERY = Symbol('avanzu.kernel.apidocs.query');
const QUERYSCHEMA = Symbol('avanzu.kernel.apidocs.queryschema');
const REQ = Symbol('avanzu.kernel.apidocs.request');
const RES = Symbol('avanzu.kernel.apidocs.response');
const ERR = Symbol('avanzu.kernel.apidocs.error');
const CODES = Symbol('avanzu.kernel.apidocs.errorcode');
const INFO = Symbol('avanzu.kernel.apidocs.info');
function ApiDocs(opts) {
    return function (target) {
        Reflect.defineMetadata(APIDOCS, opts, target);
    };
}
exports.ApiDocs = ApiDocs;
/**
 * @internal
 */
function getApiDocs(target) {
    return Reflect.hasMetadata(APIDOCS, target) ? Reflect.getMetadata(APIDOCS, target) : null;
}
exports.getApiDocs = getApiDocs;
function Contract(contract) {
    return function (target, propertyKey) {
        if (contract.params)
            Reflect.defineMetadata(PARAMS, contract.params, target, propertyKey);
        if (contract.query)
            Reflect.defineMetadata(QUERY, contract.query, target, propertyKey);
        if (contract.request)
            Reflect.defineMetadata(REQ, contract.request, target, propertyKey);
        if (contract.response)
            Reflect.defineMetadata(RES, contract.response, target, propertyKey);
        if (contract.errors)
            Reflect.defineMetadata(ERR, contract.errors, target, propertyKey);
        if (contract.info)
            Reflect.defineMetadata(INFO, contract.info, target, propertyKey);
        if (contract.errorCodes)
            Reflect.defineMetadata(CODES, contract.errorCodes, target, propertyKey);
        if (contract.querySchema) {
            Reflect.defineMetadata(QUERYSCHEMA, contract.querySchema, target, propertyKey);
        }
    };
}
exports.Contract = Contract;
function ParamSchema(params) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(PARAMS, params, target, propertyKey);
    };
}
exports.ParamSchema = ParamSchema;
/**
 * @internal
 */
function getParamSchema(target, property) {
    return Reflect.getMetadata(PARAMS, target.prototype, property);
}
exports.getParamSchema = getParamSchema;
function QuerySchema(params) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(QUERY, params, target, propertyKey);
    };
}
exports.QuerySchema = QuerySchema;
/**
 * @internal
 */
function getQuerySchema(target, property) {
    return Reflect.getMetadata(QUERY, target.prototype, property);
}
exports.getQuerySchema = getQuerySchema;
function getSimpleQuerySchema(target, property) {
    return Reflect.getMetadata(QUERYSCHEMA, target.prototype, property);
}
exports.getSimpleQuerySchema = getSimpleQuerySchema;
function RequestSchema(schema) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(REQ, schema, target, propertyKey);
    };
}
exports.RequestSchema = RequestSchema;
/**
 * @internal
 */
function getRequestSchema(target, property) {
    return Reflect.getMetadata(REQ, target.prototype, property);
}
exports.getRequestSchema = getRequestSchema;
function ResponseSchema(schema) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(RES, schema, target, propertyKey);
    };
}
exports.ResponseSchema = ResponseSchema;
/**
 * @internal
 */
function getResponseSchema(target, property) {
    return Reflect.getMetadata(RES, target.prototype, property);
}
exports.getResponseSchema = getResponseSchema;
function ErrorSchema(schema) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(ERR, schema, target, propertyKey);
    };
}
exports.ErrorSchema = ErrorSchema;
/**
 * @internal
 */
function getErrorSchema(target, property) {
    return Reflect.getMetadata(ERR, target.prototype, property);
}
exports.getErrorSchema = getErrorSchema;
function ErrorStatusCodes(codes) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(CODES, codes, target, propertyKey);
    };
}
exports.ErrorStatusCodes = ErrorStatusCodes;
/**
 * @internal
 */
function getErrorCodes(target, property) {
    return Reflect.getMetadata(CODES, target.prototype, property);
}
exports.getErrorCodes = getErrorCodes;
function Info(info) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(INFO, info, target, propertyKey);
    };
}
exports.Info = Info;
/**
 * @internal
 */
function getInfo(target, property) {
    return Reflect.getMetadata(INFO, target.prototype, property);
}
exports.getInfo = getInfo;
//# sourceMappingURL=docs.js.map