"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractContainerBuilder = void 0;
const awilix_1 = require("awilix");
const Bus = __importStar(require("../messageBus"));
const awilix_manager_1 = require("awilix-manager");
class AbstractContainerBuilder {
    getModules() {
        return [];
    }
    async build(container) {
        this.registerMessageBus(container);
        this.buildMainContainer(container);
        for (let containerModule of this.getModules()) {
            containerModule.configure(container);
            for (let spec of containerModule.getEventhandlers()) {
                let serviceKey = [
                    containerModule.getName(),
                    spec.eventName,
                    spec.eventVersion,
                ].join('_');
                container.register(serviceKey, spec.resolver);
                this.registerLazyHandler(container, spec, serviceKey);
            }
        }
    }
    registerMessageBus(container) {
        const containerOptions = {
            lifetime: 'SINGLETON',
            asyncInit: 'initialize',
            asyncDispose: 'dispose',
        };
        const resolver = (0, awilix_1.asClass)(Bus.LocalMessageBus, containerOptions).inject((container) => ({
            eventHandlers: Object.values((0, awilix_manager_1.getWithTags)(container, [Bus.ContainerTags.EventHandler])),
        }));
        container.register('messageBus', resolver);
    }
    registerLazyHandler(container, spec, serviceKey) {
        let lazyKey = `lazy_${serviceKey}`;
        const resolverOptions = {
            lifetime: 'SINGLETON',
            tags: [Bus.ContainerTags.EventHandler],
        };
        const resolver = (0, awilix_1.asClass)(Bus.LazyEventHandler, resolverOptions);
        const injector = resolver.inject((container) => ({ spec, serviceKey, container }));
        container.register(lazyKey, injector);
    }
}
exports.AbstractContainerBuilder = AbstractContainerBuilder;
//# sourceMappingURL=containerBuilder.js.map