"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationError = void 0;
const http_status_codes_1 = require("http-status-codes");
const kernelError_1 = require("./kernelError");
const errorCodes_1 = require("./errorCodes");
class ValidationError extends kernelError_1.KernelError {
    constructor(errors = []) {
        super('Invalid request payload');
        this.errors = errors;
        this.status = http_status_codes_1.StatusCodes.BAD_REQUEST;
        this.reason = http_status_codes_1.ReasonPhrases.BAD_REQUEST;
        this.code = errorCodes_1.ErrorCodes.VALIDATION;
    }
    get details() {
        return this.errors;
    }
}
exports.ValidationError = ValidationError;
//# sourceMappingURL=validationError.js.map