import { AuthUser } from "./app";
export declare const PermissionKinds: {
    ACTION: string;
    DATA: string;
    WORKFLOW: string;
};
export type PermissionKind = keyof typeof PermissionKinds;
export interface Permission {
    kind: PermissionKind;
    name: string;
}
export declare const AuthorizationResults: {
    GRANTED: string;
    DENIED: string;
    NONE: string;
};
export type AuthorizationResult = keyof typeof AuthorizationResults;
export interface Authorization {
    isGranted(user: AuthUser, permission: Permission): Promise<AuthorizationResult>;
}
