import { Container, DomainEvent, EventHandler, EventHandlerSpec, Logger, MessageBus } from "../interfaces";
export declare class LazyEventHandler<EventBody> implements EventHandler<EventBody> {
    private spec;
    private serviceKey;
    private container;
    private messageBus;
    constructor(spec: EventHandlerSpec, serviceKey: string, container: Container);
    get eventName(): string;
    get eventVersion(): number;
    usingMessageBus(owner: MessageBus): void;
    handleEvent(event: DomainEvent<EventBody>): Promise<void>;
}
export declare class LocalMessageBus implements MessageBus {
    private eventHandlers;
    private logger;
    constructor(eventHandlers: EventHandler<any>[], appLogger: Logger);
    initialize(): Promise<void>;
    dispose(): Promise<void>;
    publishEvent<EventBody = unknown>(event: DomainEvent<EventBody>): Promise<boolean>;
    subscribeToEvent(eventHandler: EventHandler<unknown>): void;
    private handlerInfo;
    unsubscribeFromEvent(eventHandler: EventHandler<unknown>): void;
}
