"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authenticate = void 0;
function authenticate() {
    return function authenticateToken(context, next) {
        let token = context.get('Authorization');
        if (false === Boolean(token)) {
            return next();
        }
        if (token.toLocaleLowerCase().startsWith('bearer')) {
            token = token.trim().split(' ').at(-1);
        }
        context.user = context.scope.cradle.authenticator.verifyToken(token);
        return next();
    };
}
exports.authenticate = authenticate;
//# sourceMappingURL=authenticate.js.map