"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorHandler = void 0;
const awilix_1 = require("awilix");
const __1 = require("..");
function errorHandler(logger) {
    return async function errorHandlerMiddleware(context, next) {
        try {
            await next();
        }
        catch (error) {
            const ErrorView = (0, __1.getErrorView)();
            const view = context.scope.build((0, awilix_1.asClass)(ErrorView).inject(() => ({ error })));
            context.status = view.getStatus();
            context.body = view;
            logger.error(`${view.status} ${view.reason}`, { ...view.toJSON(), stack: view.stack });
        }
    };
}
exports.errorHandler = errorHandler;
//# sourceMappingURL=errorHandler.js.map