"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
const errors_1 = require("../errors");
function validate(schema, location = 'body') {
    return async function validatorMiddleware(context, next) {
        const validator = context.scope.cradle.validator;
        const payload = location === 'query' ? context.query : context.request.body;
        const result = await validator.validate(schema, payload);
        if (false === result.isValid) {
            throw new errors_1.ValidationError(result.errors);
        }
        return next();
    };
}
exports.validate = validate;
//# sourceMappingURL=validate.js.map