import type { AppServices, Authenticator, Configuration, Container, ContainerModule, EventHandlerSpec } from "../../interfaces";
import { type AuthenticatorOptions } from "./jwtAuthenticator";
export type AuthenticationModuleExports = {
    authenticator: Authenticator;
};
export type AuthenticationConfiguration = {
    authenticator: AuthenticatorOptions;
};
export declare class AuthenticationContainerModule implements ContainerModule<AuthenticationModuleExports> {
    private options;
    constructor(options: Configuration<AuthenticationConfiguration>);
    getName(): string;
    getEventhandlers(): EventHandlerSpec[];
    configure(container: Container<AppServices & AuthenticationModuleExports>): void;
}
