"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationContainerModule = void 0;
const jwtAuthenticator_1 = require("./jwtAuthenticator");
const awilix_1 = require("awilix");
class AuthenticationContainerModule {
    constructor(options) {
        this.options = options;
    }
    getName() {
        return this.constructor.name;
    }
    getEventhandlers() {
        return [];
    }
    configure(container) {
        const resolver = (0, awilix_1.asClass)(jwtAuthenticator_1.JWTAuthenticator).inject(() => ({
            options: this.options.get('authenticator')
        }));
        container.register('authenticator', resolver);
    }
}
exports.AuthenticationContainerModule = AuthenticationContainerModule;
//# sourceMappingURL=authenticationModule.js.map