"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JWTAuthenticator = void 0;
const jwt = __importStar(require("jsonwebtoken"));
const authenticated_1 = require("./authenticated");
class JWTAuthenticator {
    constructor(options) {
        this.options = options;
    }
    createToken(user) {
        if (user.isAnonymous()) {
            //TODO: invent proper kernel error
            throw new Error('create token for anonymous user is not allowed.');
        }
        const payload = {
            sub: String(user.id),
            preferred_username: user.username,
        };
        const token = jwt.sign(payload, this.options.secret, this.options.jwt);
        user.access_token = token;
        return token;
    }
    verifyToken(token) {
        const decoded = jwt.verify(token, this.options.secret);
        if (typeof decoded === 'object') {
            return new authenticated_1.Authenticated(decoded.preferred_username, decoded.sub, token);
        }
    }
}
exports.JWTAuthenticator = JWTAuthenticator;
//# sourceMappingURL=jwtAuthenticator.js.map