"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControllerDocumentor = void 0;
const abstractDocumentor_1 = require("./abstractDocumentor");
const oas_builder_1 = __importDefault(require("@avanzu/oas-builder"));
class ControllerDocumentor extends abstractDocumentor_1.AbstractDocumentor {
    constructor() {
        super(...arguments);
        this.kind = 'generic';
    }
    getInfo(context) {
        const route = this.createRoute(context);
        const operationId = this.createOperationId(context);
        let operation = oas_builder_1.default.operation().id(operationId);
        operation = this.addInfo(operation, context);
        operation = this.addQuery(operation, context);
        operation = this.addQuerySchema(operation, context);
        operation = this.addParams(operation, context);
        operation = this.addRequestSchema(operation, context);
        operation = this.addResponseSchema(operation, context);
        operation = this.addErrorCodes(operation, context);
        operation = this.addErrorSchema(operation, context);
        operation = this.addTag(operation, context);
        const path = oas_builder_1.default.path().method(context.endpoint.verb, operation);
        return { route, path, operationId, verb: context.endpoint.verb, operation };
    }
}
exports.ControllerDocumentor = ControllerDocumentor;
//# sourceMappingURL=controllerDocumentor.js.map