import { TDoc, TPath } from '@avanzu/oas-builder';
import type { Container } from '../../interfaces';
export type InfoBlock = {
    version: string;
    description: string;
    title: string;
    namespace?: string;
};
export declare class OpenApi {
    protected info: InfoBlock;
    protected container: Container;
    protected paths: Map<string, TPath>;
    protected document: TDoc;
    protected tags: Set<string>;
    constructor(info: InfoBlock, container: Container);
    generate(): any;
    private addTag;
    private processController;
    private isGenericDocumentor;
    private isCustomDocumentor;
    private useCustomDocumentor;
    private useGenericDocumentor;
}
