import { AppServices, Configuration, Container, ContainerModule, EventHandlerSpec, Logger } from "../../interfaces";
import { LoggerOptions } from "pino";
export type LoggingModuleExports = {
    appLogger: Logger;
};
export type LoggingConfiguration = {
    logger: LoggerOptions;
};
export declare class LoggingContainerModule implements ContainerModule<LoggingModuleExports> {
    private config;
    constructor(config: Configuration<LoggingConfiguration>);
    getName(): string;
    configure(container: Container<AppServices & LoggingModuleExports>): void;
    getEventhandlers(): EventHandlerSpec[];
}
