"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggingContainerModule = void 0;
const pinoLogger_1 = require("./pinoLogger");
const awilix_1 = require("awilix");
class LoggingContainerModule {
    constructor(config) {
        this.config = config;
    }
    getName() {
        return this.constructor.name;
    }
    configure(container) {
        const resolver = (0, awilix_1.asClass)(pinoLogger_1.PinoLogger).inject(() => ({ options: this.config.get('logger') }));
        container.register('appLogger', resolver);
    }
    getEventhandlers() {
        return [];
    }
}
exports.LoggingContainerModule = LoggingContainerModule;
//# sourceMappingURL=loggingModule.js.map