"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PinoLogger = void 0;
const pino_1 = __importDefault(require("pino"));
const decorators_1 = require("@avanzu/decorators");
class PinoLogger {
    constructor(options) {
        this.pino = (0, pino_1.default)({ ...options });
        decorators_1.LogBox.use(this);
    }
    debug(message, metadata) {
        this.pino.debug({ ...metadata }, message);
    }
    info(message, metadata) {
        this.pino.info({ ...metadata }, message);
    }
    warn(message, metadata) {
        this.pino.warn({ ...metadata }, message);
    }
    error(message, metadata) {
        this.pino.error({ ...metadata }, message);
    }
}
exports.PinoLogger = PinoLogger;
//# sourceMappingURL=pinoLogger.js.map