import { PluginHookContext } from './HookContext';
import type { Plugin, RemotePluginDefinition } from './plugin';
import { Static } from '@sinclair/typebox';
import type { Validator } from '../../interfaces';
export declare const PluginResponseSchema: import("@sinclair/typebox").TObject<{
    hook: import("@sinclair/typebox").TString;
    data: import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TUnknown>;
    signature: import("@sinclair/typebox").TString;
}>;
export type PluginResponse = Static<typeof PluginResponseSchema>;
export declare class RemotePlugin implements Plugin {
    private definition;
    private validator;
    constructor(definition: RemotePluginDefinition, validator: Validator);
    name(): string;
    version(): string;
    dependsOn(): string[];
    description(): string;
    invoke(context: PluginHookContext): Promise<PluginHookContext>;
    private isSignatureValid;
}
