import { KernelError } from '../../errors';
import type { Plugin } from './plugin';
export declare class PluginAlreadyRegistered extends KernelError {
    protected plugin: Plugin;
    status: number;
    reason: string;
    code: string;
    constructor(plugin: Plugin);
}
export declare class CircularDependency extends KernelError {
    protected plugin: Plugin;
    protected visiting: string[];
    status: number;
    reason: string;
    code: string;
    constructor(plugin: Plugin, visiting: string[]);
    get details(): {
        plugin: string;
        visiting: string[];
    };
}
export declare class MissingDependency extends KernelError {
    protected plugin: Plugin;
    protected dependency: string;
    status: number;
    reason: string;
    code: string;
    constructor(plugin: Plugin, dependency: string);
}
export declare class PluginInvocationError extends KernelError {
    protected plugin: Plugin;
    protected error: any;
    status: number;
    reason: string;
    code: string;
    constructor(plugin: Plugin, error: any);
    get details(): {
        plugin: string;
        error: string;
    };
}
