import { PluginHookContext } from './HookContext';
import { type Plugin } from './plugin';
import { PluginRegistry } from './pluginRegistry';
export declare class PluginManager {
    protected pluginRegistry: PluginRegistry;
    protected plugins: Map<string, Plugin>;
    constructor(pluginRegistry: PluginRegistry);
    initialize(): Promise<void>;
    dispose(): Promise<void>;
    register(...plugins: Plugin[]): void;
    invoke(context: PluginHookContext): Promise<PluginHookContext>;
    protected sort(plugins: Plugin[]): Plugin[];
}
