"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AJVValidator = void 0;
class AJVValidator {
    constructor(ajv) {
        this.ajv = ajv;
    }
    getValidator(schema) {
        if (false === Boolean(schema.$id)) {
            return this.ajv.compile(schema);
        }
        return this.ajv.getSchema(schema.$id) ?? this.ajv.compile(schema);
    }
    async validate(schema, data) {
        const validator = this.getValidator(schema);
        const isValid = Boolean(validator(data));
        return { isValid, errors: validator.errors };
    }
}
exports.AJVValidator = AJVValidator;
//# sourceMappingURL=ajvValidator.js.map