"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationContainerModule = void 0;
const awilix_1 = require("awilix");
const ajvValidator_1 = require("./ajvValidator");
const ajv_1 = __importDefault(require("ajv"));
class ValidationContainerModule {
    constructor(config) {
        this.config = config;
    }
    getName() {
        return this.constructor.name;
    }
    configure(container) {
        const resolver = (0, awilix_1.asClass)(ajv_1.default).singleton().inject(() => ({ opts: this.config.get('validator') }));
        container.register('ajv', resolver);
        container.register('validator', (0, awilix_1.asClass)(ajvValidator_1.AJVValidator));
    }
    getEventhandlers() {
        return [];
    }
}
exports.ValidationContainerModule = ValidationContainerModule;
//# sourceMappingURL=validationModule.js.map