"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluggableKernel = void 0;
/**
 * @module Kernel
 */
const kernel_1 = require("./kernel");
const modules_1 = require("./modules");
/**
 * @experimental
 */
class PluggableKernel extends kernel_1.Kernel {
    async boot() {
        await super.boot();
        this.plugins = this.container.build(modules_1.PluginManager);
        await this.plugins.initialize();
        await this.plugins.invoke(new modules_1.PluginHookContext('kernel.boot', this, {}));
    }
    async shutdown() {
        await this.plugins?.invoke(new modules_1.PluginHookContext('kernel.shutdown', this, {}));
        await this.plugins?.dispose();
        await super.shutdown();
    }
}
exports.PluggableKernel = PluggableKernel;
//# sourceMappingURL=pluggableKernel.js.map